Bug 1725840 - Review Request: pcsc-lite-acsccid - ACS CCID PC/SC Driver for Linux/Mac OS X
Summary: Review Request: pcsc-lite-acsccid - ACS CCID PC/SC Driver for Linux/Mac OS X
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1723030
TreeView+ depends on / blocked
 
Reported: 2019-07-01 14:26 UTC by Jakub Jelen
Modified: 2020-06-14 07:54 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-06-14 07:54:22 UTC
Type: ---
loganjerry: fedora-review+


Attachments (Terms of Use)

Description Jakub Jelen 2019-07-01 14:26:28 UTC
Spec URL: https://jjelen.fedorapeople.org/pcsc-lite-acsccid.spec
SRPM URL: https://jjelen.fedorapeople.org/pcsc-lite-acsccid-1.1.6-1.fc31.src.rpm
Description: 

acsccid is a PC/SC driver for Linux/Mac OS X and it supports ACS CCID smart card
readers. This library provides a PC/SC IFD handler implementation and
communicates with the readers through the PC/SC Lite resource manager (pcscd).


Fedora Account System Username: jjelen

Based on the following user request:

https://bugzilla.redhat.com/show_bug.cgi?id=1723030

Copr build:

https://copr.fedorainfracloud.org/coprs/jjelen/pcsc-lite-acsccid/

Feel free to reply with your package to review in exchange.

Comment 1 Jerry James 2019-07-08 14:54:25 UTC
I will take this review.

Comment 2 Jerry James 2019-07-08 15:54:04 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== Issues ====

1. The project does advertise its license as LGPLv2+.  However, there are files
   with other licenses.

   MIT:
   src/simclist.c
   src/simclist.h
   src/strlcpy.c

   BSD:
   src/misc.h
   src/openct: the entire directory
   src/parser.h
   src/strlcpycat.h
   src/tokenparser.l

2. For ease of verifying that the correct compiler flags are in use, please
   either pass --disable-silent-rules to %configure, or add V=1 to the make
   invocation.  Incidentally, the %make_build macro is equivalent to the make
   invocation in the spec file.  It's a convenient shorthand that I recommend.

3. The package does contain bundled libraries.  They must either be unbundled
   or the correct Provides added to the spec file, as described here:
   https://docs.fedoraproject.org/en-US/packaging-guidelines/#bundling

   The bundled libraries I see are:
   SimCList: http://mij.oltrelinux.com/devel/simclist/
   OpenCT: https://github.com/OpenSC/openct/wiki

4. Add the -p flag to the install invocations in %install to preserve
   timestamps.

5. Fix the script-without-shebang error produced by rpmlint; see below.
   *Both* invocations of install in %install should pass -m 644.

6. The .so has undefined symbols:

   $ ldd -r /usr/lib64/pcsc/drivers/ifd-acsccid.bundle/Contents/Linux/libasccid.so
           linux-vdso.so.1 (0x00007ffc3257b000)
           libusb-1.0.so.0 => /lib64/libusb-1.0.so.0 (0x00007f121ef66000)
           libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f121ef45000)
           libc.so.6 => /lib64/libc.so.6 (0x00007f121ed7e000)
           libudev.so.1 => /lib64/libudev.so.1 (0x00007f121ed51000)
           /lib64/ld-linux-x86-64.so.2 (0x00007f121efae000)
           libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x00007f121ed37000)
   undefined symbol: log_xxd	(./libacsccid.so)
   undefined symbol: log_msg	(./libacsccid.so)

   Those symbols are defined in src/debug.c, which is apparently not linked
   into the final .so.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

This is okay.  The .so is a plugin, not a library in the ld path.

[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GPL (v2 or later)", "BSD 3-clause
     "New" or "Revised" License", "FSF Unlimited License (with Retention)",
     "Expat License", "GNU General Public License", "FSF Unlimited License
     (with Retention) GNU General Public License", "GNU Lesser General
     Public License (v2.1 or later)", "ISC License", "GNU Lesser General
     Public License (v2 or later)". 37 files have unknown license. Detailed
     output of licensecheck in /home/jjames/1725840-pcsc-lite-
     acsccid/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 133120 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: pcsc-lite-acsccid-1.1.6-1.fc31.x86_64.rpm
          pcsc-lite-acsccid-debuginfo-1.1.6-1.fc31.x86_64.rpm
          pcsc-lite-acsccid-debugsource-1.1.6-1.fc31.x86_64.rpm
          pcsc-lite-acsccid-1.1.6-1.fc31.src.rpm
pcsc-lite-acsccid.x86_64: W: spelling-error %description -l en_US pcscd 
pcsc-lite-acsccid.x86_64: W: spelling-error %description -l en_US ccid -> kid, acid
pcsc-lite-acsccid.x86_64: E: script-without-shebang /usr/share/licenses/pcsc-lite-acsccid/LICENSE.openct
pcsc-lite-acsccid.src: W: spelling-error %description -l en_US pcscd 
pcsc-lite-acsccid.src: W: spelling-error %description -l en_US ccid -> kid, acid
4 packages and 0 specfiles checked; 1 errors, 4 warnings.


Rpmlint (debuginfo)
-------------------
Checking: pcsc-lite-acsccid-debuginfo-1.1.6-1.fc31.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
pcsc-lite-acsccid.x86_64: W: spelling-error %description -l en_US pcscd 
pcsc-lite-acsccid.x86_64: W: spelling-error %description -l en_US ccid -> kid, acid
pcsc-lite-acsccid.x86_64: E: script-without-shebang /usr/share/licenses/pcsc-lite-acsccid/LICENSE.openct
3 packages and 0 specfiles checked; 1 errors, 2 warnings.


Unversioned so-files
--------------------
pcsc-lite-acsccid: /usr/lib64/pcsc/drivers/ifd-acsccid.bundle/Contents/Linux/libacsccid.so

Source checksums
----------------
https://downloads.sourceforge.net/acsccid/acsccid-1.1.6.tar.bz2 :
  CHECKSUM(SHA256) this package     : 71d505cb5309ac6b9f5b98246c8979615794488ebfdc1ccdd978116213b43539
  CHECKSUM(SHA256) upstream package : 71d505cb5309ac6b9f5b98246c8979615794488ebfdc1ccdd978116213b43539


Requires
--------
pcsc-lite-acsccid (rpmlib, GLIBC filtered):
    /bin/sh
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libusb-1.0.so.0()(64bit)
    pcsc-lite
    rtld(GNU_HASH)

pcsc-lite-acsccid-debuginfo (rpmlib, GLIBC filtered):

pcsc-lite-acsccid-debugsource (rpmlib, GLIBC filtered):



Provides
--------
pcsc-lite-acsccid:
    libacsccid.so()(64bit)
    pcsc-lite-acsccid
    pcsc-lite-acsccid(x86-64)

pcsc-lite-acsccid-debuginfo:
    debuginfo(build-id)
    pcsc-lite-acsccid-debuginfo
    pcsc-lite-acsccid-debuginfo(x86-64)

pcsc-lite-acsccid-debugsource:
    pcsc-lite-acsccid-debugsource
    pcsc-lite-acsccid-debugsource(x86-64)



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -b 1725840 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Shell-api, Generic
Disabled plugins: Haskell, Python, SugarActivity, Java, PHP, R, fonts, Ruby, Perl, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Jakub Jelen 2019-07-09 09:34:03 UTC
Thank you for the review. Comments inline.

(In reply to Jerry James from comment #2)
> [...]
> 
> ===== Issues ====
> 
> 1. The project does advertise its license as LGPLv2+.  However, there are
> files
>    with other licenses.
> 
>    MIT:
>    src/simclist.c
>    src/simclist.h
>    src/strlcpy.c
> 
>    BSD:
>    src/misc.h
>    src/openct: the entire directory
>    src/parser.h
>    src/strlcpycat.h
>    src/tokenparser.l

If I understand the licensing right, the BSD license is permissive and derivative/combined work can be licensed under different FOSS license. The same, I think apply for the MIT license.

If that is wrong understanding, I can indeed list also the other two, or what would be your proposal in this way?

> 2. For ease of verifying that the correct compiler flags are in use, please
>    either pass --disable-silent-rules to %configure, or add V=1 to the make
>    invocation.  Incidentally, the %make_build macro is equivalent to the make
>    invocation in the spec file.  It's a convenient shorthand that I
> recommend.

I used the %make_build macro. Thanks.

> 3. The package does contain bundled libraries.  They must either be unbundled
>    or the correct Provides added to the spec file, as described here:
>    https://docs.fedoraproject.org/en-US/packaging-guidelines/#bundling
> 
>    The bundled libraries I see are:
>    SimCList: http://mij.oltrelinux.com/devel/simclist/
>    OpenCT: https://github.com/OpenSC/openct/wiki

SimCList is simple copylib. I do not see that packaged in the Fedora and I do not think it make sense to do that since it is single-small file. I will specify it as a bundled.

The OpenCT directory here is to my understanding not a whole bundled library, but just parts of it with significant modification to match the requirements of this driver. Out of curiosity, I tried to compare the proto-t1.c file from upstream and there is hardly anything kept in place:

$ diff /tmp/proto-t1.c acsccid-1.1.6/src/openct/proto-t1.c | wc -l
766

I am not sure what is the best way to handle this, but I would certainly not call that a bundled library, rather derivative work.

> 4. Add the -p flag to the install invocations in %install to preserve
>    timestamps.

Fixed. Thanks

> 5. Fix the script-without-shebang error produced by rpmlint; see below.
>    *Both* invocations of install in %install should pass -m 644.

Fixed.

> 6. The .so has undefined symbols:
> 
>    $ ldd -r
> /usr/lib64/pcsc/drivers/ifd-acsccid.bundle/Contents/Linux/libasccid.so
>            linux-vdso.so.1 (0x00007ffc3257b000)
>            libusb-1.0.so.0 => /lib64/libusb-1.0.so.0 (0x00007f121ef66000)
>            libpthread.so.0 => /lib64/libpthread.so.0 (0x00007f121ef45000)
>            libc.so.6 => /lib64/libc.so.6 (0x00007f121ed7e000)
>            libudev.so.1 => /lib64/libudev.so.1 (0x00007f121ed51000)
>            /lib64/ld-linux-x86-64.so.2 (0x00007f121efae000)
>            libgcc_s.so.1 => /lib64/libgcc_s.so.1 (0x00007f121ed37000)
>    undefined symbol: log_xxd	(./libacsccid.so)
>    undefined symbol: log_msg	(./libacsccid.so)
> 
>    Those symbols are defined in src/debug.c, which is apparently not linked
>    into the final .so.

The src/Makefile.am links them to the final so only if we build the library without pcsc. These symbols are defined in /usr/include/PCSC/debuglog.h (from /usr/lib64/libpcsclite.so), which loads this library and therefore provides these symbols if I understand the logic here.

The updated spec file and srpm:

Spec URL: https://jjelen.fedorapeople.org/pcsc-lite-acsccid.spec
SRPM URL: https://jjelen.fedorapeople.org/pcsc-lite-acsccid-1.1.6-1.fc31.src.rpm

Comment 4 Jerry James 2019-07-10 01:20:21 UTC
(In reply to Jakub Jelen from comment #3)
> If I understand the licensing right, the BSD license is permissive and
> derivative/combined work can be licensed under different FOSS license. The
> same, I think apply for the MIT license.
> 
> If that is wrong understanding, I can indeed list also the other two, or
> what would be your proposal in this way?

No, that is correct.  I know some maintainers prefer to list all the licenses explicitly in this situation, so I just wanted to make sure you knew.  It is fine to keep the License tag as LGPLv2+.

> > 2. For ease of verifying that the correct compiler flags are in use, please
> >    either pass --disable-silent-rules to %configure, or add V=1 to the make
> >    invocation.  Incidentally, the %make_build macro is equivalent to the make
> >    invocation in the spec file.  It's a convenient shorthand that I
> > recommend.
> 
> I used the %make_build macro. Thanks.

Okay, but it would still be good to pass --disable-silent-rules to %configure, or add V=1 to the %make_build line.  That shows the compiler flags in use.

> SimCList is simple copylib. I do not see that packaged in the Fedora and I
> do not think it make sense to do that since it is single-small file. I will
> specify it as a bundled.

Okay, good.

> I am not sure what is the best way to handle this, but I would certainly not
> call that a bundled library, rather derivative work.

Yes, you're right.  That's OpenCT-derived code, rather than OpenCT itself.  This case is covered in the Guidelines:

https://docs.fedoraproject.org/en-US/packaging-guidelines/#bundling

See the second bullet item: "Use the Versioning Guidelines to determine an appropriate version for the library, if possible. If the library has been forked from an upstream, use the upstream version that was most recently merged in or rebased onto, or the version the original library carried at the time of the fork."  That's the case here.  The code started off as OpenCT, but was forked.  So the Provides should still be listed, with the version that OpenCT carried at the time of the fork.

> The src/Makefile.am links them to the final so only if we build the library
> without pcsc. These symbols are defined in /usr/include/PCSC/debuglog.h
> (from /usr/lib64/libpcsclite.so), which loads this library and therefore
> provides these symbols if I understand the logic here.

Okay, I suspected something of the sort was going on, but failed to find where the symbols were defined.  That's fine, then.

So please make the compiler flags visible, and add a Provides for OpenCT.  Neither issue is serious, so I will go ahead and approve this review request.

Comment 5 Jakub Jelen 2019-07-10 07:12:15 UTC
Thank you for the clarifications.

Actually, about the bundling, the pcsc-lite-acsccid is based on the pcsc-lite-ccid (per the home page [1]) and that one has already quite the same parts of openct [2]. The import to pcsc-lite-ccid was done in Jun 2004 [3], which corresponds to the openct-0.6.0 release so I will mart it as such.

[1] http://acsccid.sourceforge.net/
[2] https://salsa.debian.org/rousseau/CCID/tree/master/src
[3] https://salsa.debian.org/rousseau/CCID/commit/7bccd25ac4a8dbd825e4911f3b94bf1f37808451
[4] https://github.com/OpenSC/openct/releases/tag/openct-0.6.0

Comment 6 Gwyn Ciesla 2019-07-10 14:01:53 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/pcsc-lite-acsccid

Comment 7 Mattia Verga 2020-06-14 07:54:22 UTC
This package was approved and imported in repositories, but this review ticket was never closed.
I'm closing it now.


Note You need to log in before you can comment on or make changes to this bug.